from rocolib.api.components.Component import Component

c = Component()

c.addParameter("height", 100, paramType="length")
c.addParameter("length", 40, paramType="length")
c.addParameter("depth", 20, paramType="length")
c.addParameter("dl", 0.1, paramType="length")
c.addParameter("width", 10, paramType="length")
c.addParameter("flip", False, valueType="bool")

c.addSubcomponent("stick", "Rectangle")
c.addSubcomponent("foil","Wing")
c.addSubcomponent("split","SplitEdge")

c.addConstraint(("split","botlength"), ("length", "depth"), "[sum(x)]")
c.addConstraint(("split","toplength"), ("length", "depth"), "[x[0]/2., x[1], x[0]/2.]")

c.addConstraint(("stick","l"), "height")
c.addConstraint(("stick","w"), "depth")

c.addConstraint(("foil","bodylength"), "depth")
c.addConstraint(("foil","wingtip"), "depth")
c.addConstraint(("foil","thickness"), ("dl", "depth"), "x[0] * x[1]")
c.addConstraint(("foil","wingspan"), "width")
c.addConstraint(("foil","flip"), "flip")


c.addConnection(("split", "topedge1"), ("stick", "l"))
c.addConnection(("stick", "r"), ("foil", "tip"), angle=90)


c.inheritInterface("mount", ("split", "botedge0"))
c.inheritInterface("join", ("foil", "base"))

c.toLibrary("Foil")
